"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDirtyFieldValidation = useDirtyFieldValidation;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _ = require("./");

var _changeTracking = require("@totalsoft/change-tracking");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function useDirtyFieldValidation(rules) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  var _useState = (0, _react.useState)(true),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      dirtyOnly = _useState2[0],
      setDirtyOnly = _useState2[1];

  var isDirtyFilter = (0, _react.useCallback)(function (context) {
    if (!context.dirtyInfo) {
      return true;
    }

    return (0, _changeTracking.isPropertyDirty)(context.fieldPath.join("."), context.dirtyInfo) ? true : false;
  }, []);

  var _useValidation = (0, _.useValidation)(rules, _objectSpread({}, options, {
    fieldFilterFunc: isDirtyFilter
  }), (0, _toConsumableArray2["default"])(deps)),
      _useValidation2 = (0, _slicedToArray2["default"])(_useValidation, 3),
      validation = _useValidation2[0],
      validate = _useValidation2[1],
      reset = _useValidation2[2];

  return [validation, // Validate
  (0, _react.useCallback)(function (model, dirtyInfo) {
    if (!dirtyInfo) {
      setDirtyOnly(false);
    }

    return validate(model, {
      dirtyInfo: dirtyOnly ? dirtyInfo : undefined
    });
  }, [validate, dirtyOnly]), // Reset
  (0, _react.useCallback)(function () {
    setDirtyOnly(true);
    reset();
  }, [reset])];
}