"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useValidation = useValidation;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _pureValidations = require("@totalsoft/pure-validations");

var _validationProxy = require("../validationProxy");

var _reactI18next = require("react-i18next");

function useValidation(rules) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$isLogEnabled = _ref.isLogEnabled,
      isLogEnabled = _ref$isLogEnabled === void 0 ? true : _ref$isLogEnabled,
      _ref$logger = _ref.logger,
      logger = _ref$logger === void 0 ? console : _ref$logger,
      _ref$fieldFilterFunc = _ref.fieldFilterFunc,
      fieldFilterFunc = _ref$fieldFilterFunc === void 0 ? undefined : _ref$fieldFilterFunc;

  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  var _useState = (0, _react.useState)((0, _validationProxy.ValidationProxy)(_pureValidations.Success)),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      validation = _useState2[0],
      setValidation = _useState2[1];

  var _useTranslation = (0, _reactI18next.useTranslation)(),
      _useTranslation2 = (0, _slicedToArray2["default"])(_useTranslation, 2),
      i18n = _useTranslation2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];

  var validator = (0, _react.useMemo)(function () {
    var newValidator = rules;

    if (isLogEnabled) {
      newValidator = (0, _pureValidations.logTo)(logger)(newValidator);
    }

    if (fieldFilterFunc) {
      newValidator = (0, _pureValidations.filterFields)(fieldFilterFunc)(newValidator);
    }

    return newValidator;
  }, [rules, isLogEnabled, logger, fieldFilterFunc].concat((0, _toConsumableArray2["default"])(deps))); // eslint-disable-line react-hooks/exhaustive-deps

  (0, _react.useEffect)(function () {
    if ((0, _validationProxy.isValid)(validation)) {
      return;
    }

    var validationProxy = (0, _validationProxy.ValidationProxy)((0, _pureValidations.validate)(validator, state.model, state.context));
    setValidation(validationProxy);
  }, [i18n.language]);
  return [validation, // Validate
  (0, _react.useCallback)(function (model, context) {
    var validation = (0, _validationProxy.ValidationProxy)((0, _pureValidations.validate)(validator, model, context));
    setState({
      model: model,
      context: context
    });
    setValidation(validation);
    return (0, _validationProxy.isValid)(validation);
  }, [validator]), // Reset
  (0, _react.useCallback)(function () {
    setValidation((0, _validationProxy.ValidationProxy)(_pureValidations.Success));
    setState({});
  }, [])];
}